<?php
/**
 * Cleaning Maintenance functions and definitions
 * @package Cleaning Maintenance
 */

if ( ! function_exists( 'cleaning_maintenance_after_theme_support' ) ) :

	function cleaning_maintenance_after_theme_support() {
		
		add_theme_support( 'automatic-feed-links' );

		add_theme_support('woocommerce');
        add_theme_support('wc-product-gallery-zoom');
        add_theme_support('wc-product-gallery-lightbox');
        add_theme_support('wc-product-gallery-slider');
        add_theme_support('woocommerce', array(
            'gallery_thumbnail_image_width' => 300,
        ));

		add_theme_support(
			'custom-background',
			array(
				'default-color' => 'ffffff',
			)
		);

        load_theme_textdomain( 'cleaning-maintenance', get_template_directory() . '/languages' );

		$GLOBALS['content_width'] = apply_filters( 'cleaning_maintenance_content_width', 1140 );
		
		add_theme_support( 'post-thumbnails' );

		add_theme_support(
			'custom-logo',
			array(
				'height'      => 270,
				'width'       => 90,
				'flex-height' => true,
				'flex-width'  => true,
			)
		);
		
		add_theme_support( 'title-tag' );

		add_theme_support(
			'html5',
			array(
				'search-form',
				'comment-form',
				'comment-list',
				'gallery',
				'caption',
				'script',
				'style',
			)
		);

		add_theme_support( 'post-formats', array(
			'video',  
			'audio',  
			'gallery',
			'quote',  
			'image',  
			'link',   
			'status', 
			'aside',  
			'chat',   
		) );
		
		add_theme_support( 'align-wide' );
		add_theme_support( 'responsive-embeds' );
		add_theme_support( 'wp-block-styles' );

		require get_template_directory() . '/inc/metabox.php';
		require get_template_directory() . '/inc/homepage-setup/homepage-setup-settings.php';

		if (! defined( 'CLEANING_MAINTENANCE_DOCS_PRO' ) ){
		define('CLEANING_MAINTENANCE_DOCS_PRO',__('https://layout.omegathemes.com/steps/pro-cleaning-maintenance/','cleaning-maintenance'));
		}
		if (! defined( 'CLEANING_MAINTENANCE_BUY_NOW' ) ){
		define('CLEANING_MAINTENANCE_BUY_NOW',__('https://www.omegathemes.com/products/cleaning-services-wordpress-theme','cleaning-maintenance'));
		}
		if (! defined( 'CLEANING_MAINTENANCE_SUPPORT_FREE' ) ){
		define('CLEANING_MAINTENANCE_SUPPORT_FREE',__('https://wordpress.org/support/theme/cleaning-maintenance/','cleaning-maintenance'));
		}
		if (! defined( 'CLEANING_MAINTENANCE_REVIEW_FREE' ) ){
		define('CLEANING_MAINTENANCE_REVIEW_FREE',__('https://wordpress.org/support/theme/cleaning-maintenance/reviews/#new-post/','cleaning-maintenance'));
		}
		if (! defined( 'CLEANING_MAINTENANCE_DEMO_PRO' ) ){
		define('CLEANING_MAINTENANCE_DEMO_PRO',__('https://layout.omegathemes.com/cleaning-maintenance/','cleaning-maintenance'));
		}
		if (! defined( 'CLEANING_MAINTENANCE_LITE_DOCS_PRO' ) ){
		define('CLEANING_MAINTENANCE_LITE_DOCS_PRO',__('https://layout.omegathemes.com/steps/free-cleaning-maintenance/','cleaning-maintenance'));
		}
		if (! defined( 'CLEANING_MAINTENANCE_BUNDLE_BUTTON' ) ){
			define('CLEANING_MAINTENANCE_BUNDLE_BUTTON',__('https://www.omegathemes.com/products/wp-theme-bundle','cleaning-maintenance'));
		}

	}

endif;

add_action( 'after_setup_theme', 'cleaning_maintenance_after_theme_support' );

/**
 * Register and Enqueue Styles.
 */
function cleaning_maintenance_register_styles() {

	wp_enqueue_style( 'dashicons' );

    $cleaning_maintenance_theme_version = wp_get_theme()->get( 'Version' );
	$cleaning_maintenance_fonts_url = cleaning_maintenance_fonts_url();
    if( $cleaning_maintenance_fonts_url ){
    	require_once get_theme_file_path( 'lib/custom/css/wptt-webfont-loader.php' );
        wp_enqueue_style(
			'cleaning-maintenance-google-fonts',
			cleaning_maintenance_wptt_get_webfont_url( $cleaning_maintenance_fonts_url ),
			array(),
			$cleaning_maintenance_theme_version
		);
    }

    wp_enqueue_style( 'swiper', get_template_directory_uri() . '/lib/swiper/css/swiper-bundle.min.css');
	wp_enqueue_style( 'cleaning-maintenance-style', get_stylesheet_uri(), array(), $cleaning_maintenance_theme_version );

	wp_enqueue_style( 'cleaning-maintenance-style', get_stylesheet_uri() );
	require get_parent_theme_file_path( '/custom_css.php' );
	wp_add_inline_style( 'cleaning-maintenance-style',$cleaning_maintenance_custom_css );

	$cleaning_maintenance_css = '';

	if ( get_header_image() ) :

		$cleaning_maintenance_css .=  '
			#center-header{
				background-image: url('.esc_url(get_header_image()).') !important;
				-webkit-background-size: cover !important;
				-moz-background-size: cover !important;
				-o-background-size: cover !important;
				background-size: cover !important;
			}';

	endif;

	wp_add_inline_style( 'cleaning-maintenance-style', $cleaning_maintenance_css );

	if ( is_singular() && comments_open() && get_option( 'thread_comments' ) ) {
		wp_enqueue_script( 'comment-reply' );
	}	

	wp_enqueue_script( 'imagesloaded' );
    wp_enqueue_script( 'masonry' );
	wp_enqueue_script( 'swiper', get_template_directory_uri() . '/lib/swiper/js/swiper-bundle.min.js', array('jquery'), '', 1);
	wp_enqueue_script( 'cleaning-maintenance-custom', get_template_directory_uri() . '/lib/custom/js/theme-custom-script.js', array('jquery'), '', 1);

    // Global Query
    if( is_front_page() ){

    	$cleaning_maintenance_posts_per_page = absint( get_option('posts_per_page') );
        $cleaning_maintenance_c_paged = ( get_query_var( 'page' ) ) ? absint( get_query_var( 'page' ) ) : 1;
        $cleaning_maintenance_posts_args = array(
            'posts_per_page'        => $cleaning_maintenance_posts_per_page,
            'paged'                 => $cleaning_maintenance_c_paged,
        );
        $cleaning_maintenance_posts_qry = new WP_Query( $cleaning_maintenance_posts_args );
        $cleaning_maintenance_max = $cleaning_maintenance_posts_qry->max_num_pages;

    }else{
        global $wp_query;
        $cleaning_maintenance_max = $wp_query->max_num_pages;
        $cleaning_maintenance_c_paged = ( get_query_var( 'paged' ) > 1 ) ? get_query_var( 'paged' ) : 1;
    }

    $cleaning_maintenance_default = cleaning_maintenance_get_default_theme_options();
    $cleaning_maintenance_pagination_layout = get_theme_mod( 'cleaning_maintenance_pagination_layout',$cleaning_maintenance_default['cleaning_maintenance_pagination_layout'] );
}

add_action( 'wp_enqueue_scripts', 'cleaning_maintenance_register_styles',200 );

function cleaning_maintenance_admin_enqueue_scripts_callback() {
    if ( ! did_action( 'wp_enqueue_media' ) ) {
    wp_enqueue_media();
    }
    wp_enqueue_script('cleaning-maintenance-uploaderjs', get_stylesheet_directory_uri() . '/lib/custom/js/uploader.js', array(), "1.0", true);
}
add_action( 'admin_enqueue_scripts', 'cleaning_maintenance_admin_enqueue_scripts_callback' );

/**
 * Register navigation menus uses wp_nav_menu in five places.
 */
function cleaning_maintenance_menus() {

	$cleaning_maintenance_locations = array(
		'cleaning-maintenance-primary-menu'  => esc_html__( 'Primary Menu', 'cleaning-maintenance' ),
	);

	register_nav_menus( $cleaning_maintenance_locations );
}

add_action( 'init', 'cleaning_maintenance_menus' );

add_filter('loop_shop_columns', 'cleaning_maintenance_loop_columns');
if (!function_exists('cleaning_maintenance_loop_columns')) {
	function cleaning_maintenance_loop_columns() {
		$cleaning_maintenance_columns = get_theme_mod( 'cleaning_maintenance_per_columns', 3 );
		return $cleaning_maintenance_columns;
	}
}

add_filter( 'loop_shop_per_page', 'cleaning_maintenance_per_page', 20 );
function cleaning_maintenance_per_page( $cleaning_maintenance_cols ) {
  	$cleaning_maintenance_cols = get_theme_mod( 'cleaning_maintenance_product_per_page', 9 );
	return $cleaning_maintenance_cols;
}

add_filter( 'woocommerce_output_related_products_args', 'cleaning_maintenance_products_args' );

function cleaning_maintenance_products_args( $cleaning_maintenance_args ) {

    $cleaning_maintenance_args['posts_per_page'] = get_theme_mod( 'cleaning_maintenance_custom_related_products_number', 6 );

    $cleaning_maintenance_args['columns'] = get_theme_mod( 'cleaning_maintenance_custom_related_products_number_per_row', 3 );

    return $cleaning_maintenance_args;
}

require get_template_directory() . '/inc/custom-header.php';
require get_template_directory() . '/classes/class-svg-icons.php';
require get_template_directory() . '/classes/class-walker-menu.php';
require get_template_directory() . '/inc/customizer/customizer.php';
require get_template_directory() . '/inc/custom-functions.php';
require get_template_directory() . '/inc/template-tags.php';
require get_template_directory() . '/classes/body-classes.php';
require get_template_directory() . '/inc/widgets/widgets.php';
require get_template_directory() . '/inc/pagination.php';
require get_template_directory() . '/lib/breadcrumbs/breadcrumbs.php';
require get_template_directory() . '/lib/custom/css/dynamic-style.php';


function cleaning_maintenance_remove_customize_register() {
    global $wp_customize;

    $wp_customize->remove_setting( 'display_header_text' );
    $wp_customize->remove_control( 'display_header_text' );

}

add_action( 'customize_register', 'cleaning_maintenance_remove_customize_register', 11 );

function cleaning_maintenance_radio_sanitize(  $cleaning_maintenance_input, $cleaning_maintenance_setting  ) {
	$cleaning_maintenance_input = sanitize_key( $cleaning_maintenance_input );
	$cleaning_maintenance_choices = $cleaning_maintenance_setting->manager->get_control( $cleaning_maintenance_setting->id )->choices;
	return ( array_key_exists( $cleaning_maintenance_input, $cleaning_maintenance_choices ) ? $cleaning_maintenance_input : $cleaning_maintenance_setting->default );
}
require get_template_directory() . '/inc/general.php';

function cleaning_maintenance_sticky_sidebar_enabled() {
    $cleaning_maintenance_sticky_sidebar = get_theme_mod('cleaning_maintenance_sticky_sidebar', true);
    
    if ($cleaning_maintenance_sticky_sidebar == false) {
        $cleaning_maintenance_custom_css = ".widget-area-wrapper { position: relative !important; }";
        wp_add_inline_style('cleaning-maintenance-style', $cleaning_maintenance_custom_css);
    }
}
add_action('wp_enqueue_scripts', 'cleaning_maintenance_sticky_sidebar_enabled');

// NOTICE FUNCTION

function cleaning_maintenance_admin_notice() { 
    global $pagenow;
    $theme_args = wp_get_theme();
    $meta = get_option( 'cleaning_maintenance_admin_notice' );
    $name = $theme_args->get( 'Name' );
    $current_screen = get_current_screen();

    if ( ! $meta ) {
        if ( is_network_admin() ) {
            return;
        }

        if ( ! current_user_can( 'manage_options' ) ) {
            return;
        }

        if ( $current_screen->base != 'appearance_page_cleaningmaintenance-wizard' ) {
            ?>
            <div class="notice notice-success notice-content">
                <h2><?php esc_html_e('Welcome! Thank you for choosing Cleaning Maintenance. Let’s Set Up Your Website!', 'cleaning-maintenance') ?> </h2>
                <p><?php esc_html_e('Before you dive into customization, let’s go through a quick setup process to ensure everything runs smoothly. Click below to start setting up your website in minutes!', 'cleaning-maintenance') ?> </p>
                <div class="info-link">
                    <a href="<?php echo esc_url( admin_url( 'themes.php?page=cleaningmaintenance-wizard' ) ); ?>"><?php esc_html_e('Get Started with Cleaning Maintenance', 'cleaning-maintenance'); ?></a>
                </div>
                <p class="dismiss-link"><strong><a href="?cleaning_maintenance_admin_notice=1"><?php esc_html_e( 'Dismiss', 'cleaning-maintenance' ); ?></a></strong></p>
            </div>
            <?php
        }
    }
}
add_action( 'admin_notices', 'cleaning_maintenance_admin_notice' );

if ( ! function_exists( 'cleaning_maintenance_update_admin_notice' ) ) :
/**
 * Updating admin notice on dismiss
 */
function cleaning_maintenance_update_admin_notice() {
    if ( isset( $_GET['cleaning_maintenance_admin_notice'] ) && $_GET['cleaning_maintenance_admin_notice'] == '1' ) {
        update_option( 'cleaning_maintenance_admin_notice', true );
    }
}
endif;
add_action( 'admin_init', 'cleaning_maintenance_update_admin_notice' );

// After Switch theme function
add_action( 'after_switch_theme', 'cleaning_maintenance_getstart_setup_options' );
function cleaning_maintenance_getstart_setup_options() {
    update_option( 'cleaning_maintenance_admin_notice', false );
}